﻿Imports System.Data
Imports System.Data.SqlClient

Module DataBase_Collection

    Public Data_Connection As New SqlConnection


    ' *************************************************************
    ' Funktionen zum Öffnen,Beschreiben und Laden einer DB
    ' *************************************************************
#Region " SQL Funktionen"
    Public Function Data_SQL_Connect(ByVal Conn_STR As String) As SqlConnection
        ' Öffenet wenn möglich die im Conn_STR angegebene Datenbank
        ' und gibt die Connection nach Oben weiter
        Dim Connection_Str As String = Conn_STR
        Try
            Data_Connection.Open()
            Return Data_Connection
        Catch ex As Exception
            Return Data_Connection
        End Try
    End Function
    Public Function Data_SQL_Close(ByVal SqlConnection As SqlConnection) As Boolean
        ' Schliesst die Angegebene Datenbank
        Try
            SqlConnection.Close()
            Data_SQL_Close = True
        Catch ex As Exception
            Data_SQL_Close = False
        End Try
    End Function

    Public Function Data_SQL_Command(ByVal Command As String) As Boolean
        ' Führt SQL Commandos wie Insert oder Andere aus die Ohne Arrayrückmeldungen manipulationen
        ' an der Datenbank durchführen
        Dim cdo As New SqlCommand
        Try
            cdo.CommandText = Command
            cdo.Connection = Data_Connection
            cdo.ExecuteNonQuery()
            Data_SQL_Command = True
        Catch ex As Exception
            Data_SQL_Command = False
        End Try
    End Function

    Public Function Data_SQL_Reader(ByVal Command As String) As Object
        ' Liest eine Abfrage aus der DB aus und gibt sie als Objekt an den Aufrufer zurück
        Dim cdo As New SqlCommand(Command, Data_Connection)
        Dim drd As SqlDataReader = cdo.ExecuteReader
        Data_SQL_Reader = Nothing
        Do While drd.Read
            drd.GetValues(Data_SQL_Reader)
        Loop
        drd.Close()

    End Function


    Public Function Data_TABLE_READ(ByVal Command As String) As DataTable
        ' Liest eine Abfrage aus der DB aus und gibt sie als Data Table an den Aufrufer zurück
        Dim cdo As New SqlCommand(Command, Data_Connection)
        Dim adp As New SqlDataAdapter(cdo)
        Dim dtbl As New DataTable
        adp.Fill(dtbl)
        Data_TABLE_READ = dtbl
    End Function

  

#End Region


End Module
